scala.tools.nsc.util

# DocStrings

###
Related Doc: package util

#### object DocStrings

Utility methods for doc comment strings

Source
  DocStrings.scala

Linear Supertypes
AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. DocStrings
2. AnyRef
3. Any

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

5. #### def cleanupSectionText(str: String): String

   Cleanup section text

6. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

7. #### final def eq(arg0: AnyRef): Boolean

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

   The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

   - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
   - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
   - `null.eq(null)` returns `true`.

   When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

   returns

     `true` if the argument is a reference to the receiver object; `false` otherwise.

   Definition Classes
     AnyRef

8. #### def equals(arg0: Any): Boolean

   The equality method for reference types.

   The equality method for reference types. Default implementation delegates to `eq`.

   See also `equals` in scala.Any.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

9. #### def extractSectionParam(str: String, section: (Int, Int)): String

   Extract the section parameter

10. #### def extractSectionTag(str: String, section: (Int, Int)): String

    Extract the section tag, treating the section tag as an indentifier

11. #### def extractSectionText(str: String, section: (Int, Int)): (Int, Int)

    Extract the section text, except for the tag and comment newlines

12. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

13. #### def findAll(str: String, start: Int)(p: (Int) ⇒ Boolean): List[Int]

    Return first index following `start` and starting a line (i.e.

    Return first index following `start` and starting a line (i.e. after skipLineLead) which satisfies predicate `p`.

14. #### def findNext(str: String, start: Int)(p: (Int) ⇒ Boolean): Int

    Returns first index following `start` and starting a line (i.e.

    Returns first index following `start` and starting a line (i.e. after skipLineLead) or starting the comment which satisfies predicate `p`.

15. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

16. #### def groupDoc(str: String, sections: List[(Int, Int)]): Option[(Int, Int)]

    Optionally start and end index of return section in `str`, or `None` if `str` does not have a @group.

17. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

18. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

19. #### def mergeInheritdocSections(str: String, idxs: List[Int]): List[Int]

    Merge the inheritdoc sections, as they never make sense on their own

20. #### def mergeUsecaseSections(str: String, idxs: List[Int]): List[Int]

    Merge sections following an usecase into the usecase comment, so they can override the parent symbol's sections

21. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

23. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### def paramDocs(str: String, tag: String, sections: List[(Int, Int)]): Map[String, (Int, Int)]

    A map from parameter names to start/end indices describing all parameter sections in `str` tagged with `tag`, where `sections` is the index of `str`.

25. #### def returnDoc(str: String, sections: List[(Int, Int)]): Option[(Int, Int)]

    Optionally start and end index of return section in `str`, or `None` if `str` does not have a @return.

26. #### def sectionTagMap(str: String, sections: List[(Int, Int)]): Map[String, (Int, Int)]

    A map from the section tag to section parameters

27. #### def skipIdent(str: String, start: Int): Int

    Returns index of string `str` following `start` skipping sequence of identifier characters.

28. #### def skipLineLead(str: String, start: Int): Int

    Returns index of string `str` after `start` skipping longest sequence of space and tab characters, possibly also containing a single `*` character or the `/``**` sequence.

29. #### def skipTag(str: String, start: Int): Int

    Returns index of string `str` following `start` skipping sequence of identifier characters.

30. #### def skipToEol(str: String, start: Int): Int

    Skips to next occurrence of `\n' or to the position after the` /``**` sequence following index` start`.`

31. #### def skipVariable(str: String, start: Int): Int

    Returns index following variable, or start index if no variable was recognized

32. #### def skipWhitespace(str: String, start: Int): Int

    Returns index of string `str` following `start` skipping longest sequence of whitespace characters characters (but no newlines)

33. #### def startTag(str: String, sections: List[(Int, Int)]): Int

    The first start tag of a list of tag intervals, or the end of the whole comment string - 2 if list is empty

34. #### def startsWithTag(str: String, start: Int, tag: String): Boolean

35. #### def startsWithTag(str: String, section: (Int, Int), tag: String): Boolean

    Does interval `iv` start with given `tag`?

36. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

37. #### def tagIndex(str: String, p: (Int) ⇒ Boolean = idx => true): List[(Int, Int)]

    Produces a string index, which is a list of `sections`, i.e pairs of start/end positions of all tagged sections in the string.

    Produces a string index, which is a list of `sections`, i.e pairs of start/end positions of all tagged sections in the string. Every section starts with an at sign and extends to the next at sign, or to the end of the comment string, but excluding the final two characters which terminate the comment.

    Also take usecases into account - they need to expand until the next usecase or the end of the string, as they might include other sections of their own

38. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

39. #### def variableName(str: String): String

    Extracts variable name from a string, stripping any pair of surrounding braces

40. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

42. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from AnyRef

### Inherited from Any

### Ungrouped